#include <string.h>
#include "swstriped.h"
#include "align2seq_swsse2.h"

/** ======================================================== */
int align2seq_swsse2(BioSubSequence &seq1, BioSubSequence& seq2)
{
   Alignment aln;
   initAlignment(&aln, seq1.size(), seq2.size());
   swStripedAlign(seq1.c_str(), seq1.size(), seq2.c_str(), seq2.size(), &aln);
   if (aln.score)
   {
      seq1.assign(aln.qAln, aln.alnLen);
      seq2.assign(aln.dAln, aln.alnLen);
      seq1.setFrom(aln.qStart);
      seq1.setTo(aln.qEnd);
      seq2.setFrom(aln.dStart);
      seq2.setTo(aln.dEnd);
   }
   else
   {
      //seq1.clear();
      //seq2.clear();
      seq1.setFrom(0);
      seq1.setTo(0);
      seq2.setFrom(0);
      seq2.setTo(0);
   }
   deleAlignment(&aln);
   return aln.score;
}

/** ======================================================== */
int align2seq_swsse2(BioSubSequence &seq1, BioSubSequence& seq2, int iGI, int iGX)
{
   if (iGI != 0)
   {
      gapInit = abs(iGI);
   }
   if (iGX != 0)
   {
      gapExt = abs(iGX);
   }
   return align2seq_swsse2(seq1, seq2);
}

