/******************************************************************
 Copyright 2006 by Michael Farrar.  All rights reserved.
 This program may not be sold or incorporated into a commercial product,
 in whole or in part, without written consent of Michael Farrar.  For
 further information regarding permission for use or reproduction, please
 contact: Michael Farrar at farrar.michael@gmail.com.
 *******************************************************************/

/*
 Written by Michael Farrar, 2006.
 Please send bug reports and/or suggestions to farrar.michael@gmail.com.
 */

#ifndef INCLUDE_SWSTRIPED_H
#define INCLUDE_SWSTRIPED_H

#include <emmintrin.h>

#include "swsse2.h"

typedef struct {
//	__m128i *pvbQueryProf;
	__m128i *pvsQueryProf;
	__m128i *pvH1;
	__m128i *pvH2;
	__m128i *pvE;
	__m128i *pvEGLLoad;
	__m128i *pvEGLStore;
	__m128i *pvDIR;
	unsigned char *pData;
	unsigned short bias;
} SwStripedData;

typedef struct {
	char *qAln;
	char *dAln;
	int alnLen;
	int qStart;
	int qEnd;
	int dStart;
	int dEnd;
	int score;
} Alignment;

extern int gapInit;
extern int gapExt;

#ifdef __cplusplus
extern "C" {
#endif

void initAlignment(Alignment* aln, int qLen, int dlen);
void deleAlignment(Alignment* aln);
void loadSWSSE2Matrix(const char* file);
void setSWSSE2Matrix(const signed char *mat, const short *char2index, const char *index2char, short alphabethSize);
SwStripedData* swStripedInit(unsigned char *querySeq, int queryLength);
void swStripedComplete(void *pSwData);
unsigned char* char2byte(const char* seq, int len);
unsigned char* char2byte_clean(const char* seq, int* len);
int swStripedAlign(const char* querySeq, int queryLength, const char* dbSeq,
		int dbLength, Alignment* aln);
int swStripedAlign_Profile(const unsigned char* qSeq, int queryLength,
		const unsigned char* dSeq, int dbLength, Alignment* aln,
		SwStripedData *stripedData);
int traceBack_Score_Word(unsigned char* querySeq, int queryLength,
		unsigned char* dbSeq, int dbLength, unsigned short* scoreMat, int iGI,
		int iGX, Alignment* aln, short local);
int traceBack_Trace_Word(const unsigned char* querySeq, int queryLength,
		const unsigned char* dbSeq, int dbLength, short* pathMat, int iMaxX,
		int iMaxY, Alignment *aln);
int swStripedWord(const unsigned char *querySeq, int queryLength,
		const unsigned char *dbSeq, int dbLength, unsigned short gapOpen,
		unsigned short gapExtend, __m128i *queryProf, __m128i *pvH1,
		__m128i *pvH2, __m128i *pvE, __m128i *pvEGLLoad, __m128i *pvEGLStore,
		__m128i *pvDIR, Alignment *aln);

#ifdef __cplusplus
}
#endif

//void setSWSSE2Matrix(const char* file);
//void initAlignment(Alignment* aln, int qLen, int dlen);
//void deleAlignment(Alignment* aln);
//int swStripedAlign (const char* querySeq, int queryLength, const char* dbSeq, int dbLength, Alignment* aln);
#endif /* INCLUDE_SWSTRIPED_H */
